diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv4-l3-protocol.h ns-3.36/src/internet/model/ipv4-l3-protocol.h
--- ns-3.35/src/internet/model/ipv4-l3-protocol.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv4-l3-protocol.h	2022-04-30 18:23:57.866733600 -0700
@@ -90,6 +90,10 @@
   Ipv4L3Protocol();
   virtual ~Ipv4L3Protocol ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  Ipv4L3Protocol (const Ipv4L3Protocol &) = delete;
+  Ipv4L3Protocol & operator = (const Ipv4L3Protocol &) = delete;
+
   /**
    * \enum DropReason
    * \brief Reason why a packet has been dropped.
@@ -225,9 +229,9 @@
   /**
    * TracedCallback signature for packet send, forward, or local deliver events.
    *
-   * \param [in] header The Ipv6Header.
-   * \param [in] packet The packet.
-   * \param [in] interface
+   * \param [in] header the Ipv4Header
+   * \param [in] packet the packet
+   * \param [in] interface IP-level interface number
    */
   typedef void (* SentTracedCallback)
       (const Ipv4Header & header, Ptr<const Packet> packet, uint32_t interface);
@@ -235,10 +239,9 @@
   /**
    * TracedCallback signature for packet transmission or reception events.
    *
-   * \param [in] header The Ipv4Header.
-   * \param [in] packet The packet.
-   * \param [in] ipv4
-   * \param [in] interface
+   * \param [in] packet the packet.
+   * \param [in] ipv4 the Ipv4 protocol
+   * \param [in] interface IP-level interface number
    * \deprecated The non-const \c Ptr<Ipv4> argument is deprecated
    * and will be changed to \c Ptr<const Ipv4> in a future release.
    */
@@ -248,11 +251,11 @@
   /**
    * TracedCallback signature for packet drop events.
    *
-   * \param [in] header The Ipv4Header.
-   * \param [in] packet The packet.
-   * \param [in] reason The reason the packet was dropped.
-   * \param [in] ipv4
-   * \param [in] interface
+   * \param [in] header the Ipv4Header.
+   * \param [in] packet the packet.
+   * \param [in] reason the reason the packet was dropped.
+   * \param [in] ipv4 the Ipv4 protocol
+   * \param [in] interface IP-level interface number
    * \deprecated The non-const \c Ptr<Ipv4> argument is deprecated
    * and will be changed to \c Ptr<const Ipv4> in a future release.
    */
@@ -276,21 +279,6 @@
    */
   friend class ::Ipv4L3ProtocolTestCase;
 
-  /**
-   * \brief Copy constructor.
-   *
-   * Defined but not implemented to avoid misuse
-   */
-  Ipv4L3Protocol(const Ipv4L3Protocol &);
-
-  /**
-   * \brief Copy constructor.
-   *
-   * Defined but not implemented to avoid misuse
-   * \returns the copied object
-   */
-  Ipv4L3Protocol &operator = (const Ipv4L3Protocol &);
-
   // class Ipv4 attributes
   virtual void SetIpForward (bool forward);
   virtual bool GetIpForward (void) const;
@@ -430,7 +418,7 @@
    * \param ipHeader the IP header that will be added to the packet
    * \param packet the packet
    * \param ipv4 the Ipv4 protocol
-   * \param interface the interface index
+   * \param interface the IP-level interface index
    *
    * Note: If the TracedCallback API ever is extended, we could consider
    * to check for connected functions before adding the header
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv4-queue-disc-item.h ns-3.36/src/internet/model/ipv4-queue-disc-item.h
--- ns-3.35/src/internet/model/ipv4-queue-disc-item.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv4-queue-disc-item.h	2022-04-30 18:23:57.866733600 -0700
@@ -46,6 +46,11 @@
 
   virtual ~Ipv4QueueDiscItem ();
 
+  // Delete default constructor, copy constructor and assignment operator to avoid misuse
+  Ipv4QueueDiscItem () = delete;
+  Ipv4QueueDiscItem (const Ipv4QueueDiscItem &) = delete;
+  Ipv4QueueDiscItem & operator = (const Ipv4QueueDiscItem &) = delete;
+
   /**
    * \return the correct packet size (header plus payload).
    */
@@ -96,26 +101,6 @@
   virtual uint32_t Hash (uint32_t perturbation) const;
 
 private:
-  /**
-   * \brief Default constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Ipv4QueueDiscItem ();
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Ipv4QueueDiscItem (const Ipv4QueueDiscItem &);
-  /**
-   * \brief Assignment operator
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  Ipv4QueueDiscItem &operator = (const Ipv4QueueDiscItem &);
-
   Ipv4Header m_header;  //!< The IPv4 header.
   bool m_headerAdded;   //!< True if the header has already been added to the packet.
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv6.h ns-3.36/src/internet/model/ipv6.h
--- ns-3.35/src/internet/model/ipv6.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv6.h	2022-04-30 18:23:57.870733500 -0700
@@ -365,7 +365,9 @@
 
   /**
    * \brief Higher-level layers call this method to send a packet
-   * down the stack to the MAC and PHY layers.
+   * down the stack to the MAC and PHY layers. All PMTU values are
+   * stored at this level, so packet size calculations should be
+   * done mathematically at higher levels.
    *
    * \param packet packet to send
    * \param source source address of packet
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv6-header.cc ns-3.36/src/internet/model/ipv6-header.cc
--- ns-3.35/src/internet/model/ipv6-header.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv6-header.cc	2022-04-30 18:23:57.870733500 -0700
@@ -194,7 +194,7 @@
     }
 
   m_trafficClass = (uint8_t)((vTcFl >> 20) & 0x000000ff);
-  m_flowLabel = vTcFl & 0xfff00000;
+  m_flowLabel = vTcFl & 0xfffff;
   m_payloadLength = i.ReadNtohU16 ();
   m_nextHeader = i.ReadU8 ();
   m_hopLimit = i.ReadU8 ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv6-interface.h ns-3.36/src/internet/model/ipv6-interface.h
--- ns-3.35/src/internet/model/ipv6-interface.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv6-interface.h	2022-04-30 18:23:57.870733500 -0700
@@ -67,6 +67,10 @@
    */
   virtual ~Ipv6Interface ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  Ipv6Interface (const Ipv6Interface &) = delete;
+  Ipv6Interface & operator = (const Ipv6Interface &) = delete;
+
   /**
    * \brief Set node associated with interface.
    * \param node node
@@ -280,23 +284,6 @@
 
 private:
   /**
-   * \brief Copy constructor
-   * \param o object to copy
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Ipv6Interface (const Ipv6Interface &o);
-
-  /**
-   * \brief Assignment operator
-   * \param o object to copy
-   * \returns the copied object
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Ipv6Interface &operator = (const Ipv6Interface &o);
-
-  /**
    * \brief Container for the Ipv6InterfaceAddresses.
    */
   typedef std::list<std::pair<Ipv6InterfaceAddress, Ipv6Address> > Ipv6InterfaceAddressList;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv6-l3-protocol.cc ns-3.36/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.35/src/internet/model/ipv6-l3-protocol.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv6-l3-protocol.cc	2022-04-30 18:23:57.870733500 -0700
@@ -601,6 +601,11 @@
   NS_LOG_FUNCTION (this << interface << dest);
   Ipv6Address ret;
 
+  if (dest.IsLocalhost ())
+    {
+      return Ipv6Address::GetLoopback ();
+    }
+  
   if (dest.IsLinkLocal () || dest.IsLinkLocalMulticast ())
     {
       for (uint32_t i = 0; i < GetNAddresses (interface); i++)
@@ -632,6 +637,8 @@
     }
 
   // no specific match found. Use a global address (any useful is fine).
+  NS_ASSERT_MSG (!ret.IsAny (),
+                 "Could not find any address for " << dest << " on interface " << interface);
   return ret;
 }
 
@@ -920,7 +927,7 @@
   else
     {
       NS_LOG_WARN ("No route to host, drop!");
-      m_dropTrace (hdr, packet, DROP_NO_ROUTE, m_node->GetObject<Ipv6> (), GetInterfaceForDevice (oif));
+      m_dropTrace (hdr, packet, DROP_NO_ROUTE, this, GetInterfaceForDevice (oif));
     }
 }
 
@@ -937,14 +944,14 @@
 
   if (ipv6Interface->IsUp ())
     {
-      m_rxTrace (packet, m_node->GetObject<Ipv6> (), interface);
+      m_rxTrace (packet, this, interface);
     }
   else
     {
       NS_LOG_LOGIC ("Dropping received packet-- interface is down");
       Ipv6Header hdr;
       packet->RemoveHeader (hdr);
-      m_dropTrace (hdr, packet, DROP_INTERFACE_DOWN, m_node->GetObject<Ipv6> (), interface);
+      m_dropTrace (hdr, packet, DROP_INTERFACE_DOWN, this, interface);
       return;
     }
 
@@ -1008,7 +1015,7 @@
 
       if (isDropped)
         {
-          m_dropTrace (hdr, packet, dropReason, m_node->GetObject<Ipv6> (), interface);
+          m_dropTrace (hdr, packet, dropReason, this, interface);
         }
 
       if (stopProcessing)
@@ -1081,9 +1088,12 @@
 Ipv6L3Protocol::CallTxTrace (const Ipv6Header & ipHeader, Ptr<Packet> packet,
                                     Ptr<Ipv6> ipv6, uint32_t interface)
 {
-  Ptr<Packet> packetCopy = packet->Copy ();
-  packetCopy->AddHeader (ipHeader);
-  m_txTrace (packetCopy, ipv6, interface);
+  if (!m_txTrace.IsEmpty ())
+  {
+    Ptr<Packet> packetCopy = packet->Copy ();
+    packetCopy->AddHeader (ipHeader);
+    m_txTrace (packetCopy, ipv6, interface);
+  }
 }
 
 void Ipv6L3Protocol::SendRealOut (Ptr<Ipv6Route> route, Ptr<Packet> packet, Ipv6Header const& ipHeader)
@@ -1106,35 +1116,42 @@
   // Check packet size
   std::list<Ipv6ExtensionFragment::Ipv6PayloadHeaderPair> fragments;
 
+  // Check if this is the source of the packet
+  bool fromMe = false;
+  for (uint32_t i = 0; i < GetNInterfaces (); i++ )
+    {
+      for (uint32_t j = 0; j < GetNAddresses (i); j++ )
+        {
+          if (GetAddress (i,j).GetAddress () == ipHeader.GetSource ())
+            {
+              fromMe = true;
+              break;
+            }
+        }
+    }
+
+  size_t targetMtu = 0;
+
   // Check if we have a Path MTU stored. If so, use it. Else, use the link MTU.
-  size_t targetMtu = (size_t)(m_pmtuCache->GetPmtu (ipHeader.GetDestination()));
+  // Note: PMTU must not be cached in intermediate nodes, and must be checked only by the source node
+  if (fromMe)
+    {
+      targetMtu = (size_t)(m_pmtuCache->GetPmtu (ipHeader.GetDestination ()));
+    }
   if (targetMtu == 0)
     {
       targetMtu = dev->GetMtu ();
     }
 
-  if (packet->GetSize () > targetMtu + 40) /* 40 => size of IPv6 header */
+  if (packet->GetSize () + ipHeader.GetSerializedSize () > targetMtu)
     {
       // Router => drop
-
-      bool fromMe = false;
-      for (uint32_t i=0; i<GetNInterfaces(); i++ )
-        {
-          for (uint32_t j=0; j<GetNAddresses(i); j++ )
-            {
-              if (GetAddress(i,j).GetAddress() == ipHeader.GetSource())
-                {
-                  fromMe = true;
-                  break;
-                }
-            }
-        }
       if (!fromMe)
         {
           Ptr<Icmpv6L4Protocol> icmpv6 = GetIcmpv6 ();
           if ( icmpv6 )
             {
-              packet->AddHeader(ipHeader);
+              packet->AddHeader (ipHeader);
               icmpv6->SendErrorTooBig (packet, ipHeader.GetSource (), dev->GetMtu ());
             }
           return;
@@ -1160,20 +1177,20 @@
 
               for (std::list<Ipv6ExtensionFragment::Ipv6PayloadHeaderPair>::const_iterator it = fragments.begin (); it != fragments.end (); it++)
                 {
-                  CallTxTrace (it->second, it->first, m_node->GetObject<Ipv6> (), interface);
+                  CallTxTrace (it->second, it->first, this, interface);
                   outInterface->Send (it->first, it->second, route->GetGateway ());
                 }
             }
           else
             {
-              CallTxTrace (ipHeader, packet, m_node->GetObject<Ipv6> (), interface);
+              CallTxTrace (ipHeader, packet, this, interface);
               outInterface->Send (packet, ipHeader, route->GetGateway ());
             }
         }
       else
         {
           NS_LOG_LOGIC ("Dropping-- outgoing interface is down: " << route->GetGateway ());
-          m_dropTrace (ipHeader, packet, DROP_INTERFACE_DOWN, m_node->GetObject<Ipv6> (), interface);
+          m_dropTrace (ipHeader, packet, DROP_INTERFACE_DOWN, this, interface);
         }
     }
   else
@@ -1188,20 +1205,20 @@
 
               for (std::list<Ipv6ExtensionFragment::Ipv6PayloadHeaderPair>::const_iterator it = fragments.begin (); it != fragments.end (); it++)
                 {
-                  CallTxTrace (it->second, it->first, m_node->GetObject<Ipv6> (), interface);
+                  CallTxTrace (it->second, it->first, this, interface);
                   outInterface->Send (it->first, it->second, ipHeader.GetDestination ());
                 }
             }
           else
             {
-              CallTxTrace (ipHeader, packet, m_node->GetObject<Ipv6> (), interface);
+              CallTxTrace (ipHeader, packet, this, interface);
               outInterface->Send (packet, ipHeader, ipHeader.GetDestination ());
             }
         }
       else
         {
           NS_LOG_LOGIC ("Dropping-- outgoing interface is down: " << ipHeader.GetDestination ());
-          m_dropTrace (ipHeader, packet, DROP_INTERFACE_DOWN, m_node->GetObject<Ipv6> (), interface);
+          m_dropTrace (ipHeader, packet, DROP_INTERFACE_DOWN, this, interface);
         }
     }
 }
@@ -1215,7 +1232,7 @@
   if (header.GetDestination().IsDocumentation ())
     {
       NS_LOG_WARN ("Received a packet for 2001:db8::/32 (documentation class).  Drop.");
-      m_dropTrace (header, p, DROP_ROUTE_ERROR, m_node->GetObject<Ipv6> (), 0);
+      m_dropTrace (header, p, DROP_ROUTE_ERROR, this, 0);
       return;
     }
 
@@ -1233,7 +1250,7 @@
   if (ipHeader.GetHopLimit () == 0)
     {
       NS_LOG_WARN ("TTL exceeded.  Drop.");
-      m_dropTrace (ipHeader, packet, DROP_TTL_EXPIRED, m_node->GetObject<Ipv6> (), 0);
+      m_dropTrace (ipHeader, packet, DROP_TTL_EXPIRED, this, 0);
       // Do not reply to multicast IPv6 address
       if (ipHeader.GetDestination ().IsMulticast () == false)
         {
@@ -1308,7 +1325,7 @@
       if (h.GetHopLimit () == 0)
         {
           NS_LOG_WARN ("TTL exceeded.  Drop.");
-          m_dropTrace (header, packet, DROP_TTL_EXPIRED, m_node->GetObject<Ipv6> (), interfaceId);
+          m_dropTrace (header, packet, DROP_TTL_EXPIRED, this, interfaceId);
           return;
         }
       NS_LOG_LOGIC ("Forward multicast via interface " << interfaceId);
@@ -1365,7 +1382,7 @@
 
           if (isDropped)
             {
-              m_dropTrace (ip, packet, dropReason, m_node->GetObject<Ipv6> (), iif);
+              m_dropTrace (ip, packet, dropReason, this, iif);
             }
 
           if (stopProcessing)
@@ -1395,7 +1412,7 @@
                 {
                   GetIcmpv6 ()->SendErrorParameterError (malformedPacket, dst, Icmpv6Header::ICMPV6_UNKNOWN_NEXT_HEADER, ip.GetSerializedSize () + nextHeaderPosition);
                 }
-              m_dropTrace (ip, p, DROP_UNKNOWN_PROTOCOL, m_node->GetObject<Ipv6> (), iif);
+              m_dropTrace (ip, p, DROP_UNKNOWN_PROTOCOL, this, iif);
               break;
             }
           else
@@ -1439,7 +1456,7 @@
   NS_LOG_FUNCTION (this << p << ipHeader << sockErrno);
   NS_LOG_LOGIC ("Route input failure-- dropping packet to " << ipHeader << " with errno " << sockErrno);
 
-  m_dropTrace (ipHeader, p, DROP_ROUTE_ERROR, m_node->GetObject<Ipv6> (), 0);
+  m_dropTrace (ipHeader, p, DROP_ROUTE_ERROR, this, 0);
 
   if (!ipHeader.GetDestination ().IsMulticast ())
     {
@@ -1520,7 +1537,7 @@
 
 void Ipv6L3Protocol::ReportDrop (Ipv6Header ipHeader, Ptr<Packet> p, DropReason dropReason)
 {
-  m_dropTrace (ipHeader, p, dropReason, m_node->GetObject<Ipv6> (), 0);
+  m_dropTrace (ipHeader, p, dropReason, this, 0);
 }
 
 void Ipv6L3Protocol::AddMulticastAddress (Ipv6Address address, uint32_t interface)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv6-l3-protocol.h ns-3.36/src/internet/model/ipv6-l3-protocol.h
--- ns-3.35/src/internet/model/ipv6-l3-protocol.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv6-l3-protocol.h	2022-04-30 18:23:57.870733500 -0700
@@ -99,6 +99,10 @@
    */
   virtual ~Ipv6L3Protocol ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  Ipv6L3Protocol (const Ipv6L3Protocol &) = delete;
+  Ipv6L3Protocol & operator = (const Ipv6L3Protocol &) = delete;
+
   /**
    * \brief Set node associated with this stack.
    * \param node node to set
@@ -372,20 +376,19 @@
    * TracedCallback signature for packet sent, forwarded or
    * local-delivered events.
    *
-   * \param [in] header The Ipv6Header.
-   * \param [in] packet The packet.
-   * \param [in] interface
+   * \param [in] header the Ipv6Header.
+   * \param [in] packet the packet.
+   * \param [in] interface the IP-level interface index
    */
   typedef void (* SentTracedCallback)
     (const Ipv6Header & header, Ptr<const Packet> packet, uint32_t interface);
-   
+
   /**
    * TracedCallback signature for packet transmission or reception events.
    *
-   * \param [in] header The Ipv6Header.
-   * \param [in] packet The packet.
-   * \param [in] ipv6
-   * \param [in] interface
+   * \param [in] packet the packet.
+   * \param [in] ipv6 the Ipv6 protocol
+   * \param [in] interface the IP-level interface index
    * \deprecated The non-const \c Ptr<Ipv6> argument is deprecated
    * and will be changed to \c Ptr<const Ipv6> in a future release.
    */
@@ -395,11 +398,11 @@
   /**
    * TracedCallback signature for packet drop events.
    *
-   * \param [in] header The Ipv6Header.
-   * \param [in] packet The packet.
-   * \param [in] reason The reason the packet was dropped.
-   * \param [in] ipv6
-   * \param [in] interface
+   * \param [in] header the Ipv6Header.
+   * \param [in] packet the packet.
+   * \param [in] reason the reason the packet was dropped.
+   * \param [in] ipv6 the Ipv6 protocol
+   * \param [in] interface the IP-level interface index
    * \deprecated The non-const \c Ptr<Ipv6> argument is deprecated
    * and will be changed to \c Ptr<const Ipv6> in a future release.
    */
@@ -533,7 +536,7 @@
    * \param ipHeader the IP header that will be added to the packet
    * \param packet the packet
    * \param ipv6 the Ipv6 protocol
-   * \param interface the interface index
+   * \param interface the IP-level interface index
    *
    * Note: If the TracedCallback API ever is extended, we could consider
    * to check for connected functions before adding the header
@@ -569,21 +572,6 @@
   TracedCallback<const Ipv6Header &, Ptr<const Packet>, uint32_t> m_localDeliverTrace;
 
   /**
-   * \brief Copy constructor.
-   *
-   * Defined but not implemented to avoid misuse
-   */
-  Ipv6L3Protocol (const Ipv6L3Protocol&);
-
-  /**
-   * \brief Copy constructor.
-   *
-   * Defined but not implemented to avoid misuse
-   * \returns the copied object
-   */
-  Ipv6L3Protocol &operator = (const Ipv6L3Protocol&);
-
-  /**
    * \brief Construct an IPv6 header.
    * \param src source IPv6 address
    * \param dst destination IPv6 address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv6-queue-disc-item.h ns-3.36/src/internet/model/ipv6-queue-disc-item.h
--- ns-3.35/src/internet/model/ipv6-queue-disc-item.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv6-queue-disc-item.h	2022-04-30 18:23:57.870733500 -0700
@@ -46,6 +46,11 @@
 
   virtual ~Ipv6QueueDiscItem ();
 
+  // Delete default constructor, copy constructor and assignment operator to avoid misuse
+  Ipv6QueueDiscItem () = delete;
+  Ipv6QueueDiscItem (const Ipv6QueueDiscItem &) = delete;
+  Ipv6QueueDiscItem & operator = (const Ipv6QueueDiscItem &) = delete;
+
   /**
    * \return the correct packet size (header plus payload).
    */
@@ -96,26 +101,6 @@
   virtual uint32_t Hash (uint32_t perturbation) const;
 
 private:
-  /**
-   * \brief Default constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Ipv6QueueDiscItem ();
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Ipv6QueueDiscItem (const Ipv6QueueDiscItem &);
-  /**
-   * \brief Assignment operator
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  Ipv6QueueDiscItem &operator = (const Ipv6QueueDiscItem &);
-
   Ipv6Header m_header;  //!< The IPv6 header.
   bool m_headerAdded;   //!< True if the header has already been added to the packet.
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ndisc-cache.h ns-3.36/src/internet/model/ndisc-cache.h
--- ns-3.35/src/internet/model/ndisc-cache.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ndisc-cache.h	2022-04-30 18:23:57.870733500 -0700
@@ -72,6 +72,10 @@
    */
   ~NdiscCache ();
 
+  // Delete default and copy constructor, and assignment operator to avoid misuse
+  NdiscCache (NdiscCache const &) = delete;
+  NdiscCache & operator = (NdiscCache const &) = delete;
+
   /**
    * \brief Get the NetDevice associated with this cache.
    * \return NetDevice
@@ -438,24 +442,7 @@
    */
   Cache m_ndCache;
 
-
 private:
-
-  /**
-   * \brief Copy constructor.
-   *
-   * Not implemented to avoid misuse
-   */
-  NdiscCache (NdiscCache const &);
-
-  /**
-   * \brief Copy constructor.
-   *
-   * Not implemented to avoid misuse
-   * \returns
-   */
-  NdiscCache& operator= (NdiscCache const &);
-
   /**
    * \brief The NetDevice.
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/rip.cc ns-3.36/src/internet/model/rip.cc
--- ns-3.35/src/internet/model/rip.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/rip.cc	2022-04-30 18:23:57.870733500 -0700
@@ -23,7 +23,6 @@
 #include "ns3/log.h"
 #include "ns3/abort.h"
 #include "ns3/assert.h"
-#include "ns3/unused.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/ipv4-route.h"
 #include "ns3/node.h"
@@ -205,7 +204,7 @@
       NS_LOG_LOGIC ("RouteOutput (): Multicast destination");
     }
 
-  rtentry = Lookup (destination, oif);
+  rtentry = Lookup (destination, true, oif);
   if (rtentry)
     {
       sockerr = Socket::ERROR_NOTERROR;
@@ -276,7 +275,7 @@
     }
   // Next, try to find a route
   NS_LOG_LOGIC ("Unicast destination");
-  Ptr<Ipv4Route> rtentry = Lookup (header.GetDestination ());
+  Ptr<Ipv4Route> rtentry = Lookup (header.GetDestination (), false);
 
   if (rtentry != 0)
     {
@@ -582,8 +581,7 @@
   Ipv4RoutingProtocol::DoDispose ();
 }
 
-
-Ptr<Ipv4Route> Rip::Lookup (Ipv4Address dst, Ptr<NetDevice> interface)
+Ptr<Ipv4Route> Rip::Lookup (Ipv4Address dst, bool setSource, Ptr<NetDevice> interface)
 {
   NS_LOG_FUNCTION (this << dst << interface);
 
@@ -633,13 +631,16 @@
                   uint32_t interfaceIdx = route->GetInterface ();
                   rtentry = Create<Ipv4Route> ();
 
-                  if (route->GetDest ().IsAny ()) /* default route */
-                    {
-                      rtentry->SetSource (m_ipv4->SourceAddressSelection (interfaceIdx, route->GetGateway ()));
-                    }
-                  else
+                  if (setSource)
                     {
-                      rtentry->SetSource (m_ipv4->SourceAddressSelection (interfaceIdx, route->GetDest ()));
+                      if (route->GetDest ().IsAny ()) /* default route */
+                        {
+                          rtentry->SetSource (m_ipv4->SourceAddressSelection (interfaceIdx, route->GetGateway ()));
+                        }
+                      else
+                        {
+                          rtentry->SetSource (m_ipv4->SourceAddressSelection (interfaceIdx, route->GetDest ()));
+                        }
                     }
 
                   rtentry->SetDestination (route->GetDest ());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/rip.h ns-3.36/src/internet/model/rip.h
--- ns-3.35/src/internet/model/rip.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/rip.h	2022-04-30 18:23:57.870733500 -0700
@@ -305,10 +305,11 @@
   /**
    * \brief Lookup in the forwarding table for destination.
    * \param dest destination address
+   * \param setSource set source address in the route
    * \param interface output interface if any (put 0 otherwise)
    * \return Ipv4Route to route the packet to reach dest address
    */
-  Ptr<Ipv4Route> Lookup (Ipv4Address dest, Ptr<NetDevice> = 0);
+  Ptr<Ipv4Route> Lookup (Ipv4Address dest, bool setSource, Ptr<NetDevice> = 0);
 
   /**
    * Receive and process unicast packet
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ripng.cc ns-3.36/src/internet/model/ripng.cc
--- ns-3.35/src/internet/model/ripng.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ripng.cc	2022-04-30 18:23:57.874733700 -0700
@@ -23,7 +23,6 @@
 #include "ns3/log.h"
 #include "ns3/abort.h"
 #include "ns3/assert.h"
-#include "ns3/unused.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/ipv6-route.h"
 #include "ns3/node.h"
@@ -197,7 +196,7 @@
       NS_LOG_LOGIC ("RouteOutput (): Multicast destination");
     }
 
-  rtentry = Lookup (destination, oif);
+  rtentry = Lookup (destination, true, oif);
   if (rtentry)
     {
       sockerr = Socket::ERROR_NOTERROR;
@@ -250,7 +249,7 @@
     }
   // Next, try to find a route
   NS_LOG_LOGIC ("Unicast destination");
-  Ptr<Ipv6Route> rtentry = Lookup (header.GetDestination ());
+  Ptr<Ipv6Route> rtentry = Lookup (header.GetDestination (), false);
 
   if (rtentry != 0)
     {
@@ -555,8 +554,7 @@
   Ipv6RoutingProtocol::DoDispose ();
 }
 
-
-Ptr<Ipv6Route> RipNg::Lookup (Ipv6Address dst, Ptr<NetDevice> interface)
+Ptr<Ipv6Route> RipNg::Lookup (Ipv6Address dst, bool setSource, Ptr<NetDevice> interface)
 {
   NS_LOG_FUNCTION (this << dst << interface);
 
@@ -606,17 +604,20 @@
                   uint32_t interfaceIdx = route->GetInterface ();
                   rtentry = Create<Ipv6Route> ();
 
-                  if (route->GetGateway ().IsAny ())
-                    {
-                      rtentry->SetSource (m_ipv6->SourceAddressSelection (interfaceIdx, route->GetDest ()));
-                    }
-                  else if (route->GetDest ().IsAny ()) /* default route */
-                    {
-                      rtentry->SetSource (m_ipv6->SourceAddressSelection (interfaceIdx, route->GetPrefixToUse ().IsAny () ? dst : route->GetPrefixToUse ()));
-                    }
-                  else
+                  if (setSource)
                     {
-                      rtentry->SetSource (m_ipv6->SourceAddressSelection (interfaceIdx, route->GetDest ()));
+                      if (route->GetGateway ().IsAny ())
+                        {
+                          rtentry->SetSource (m_ipv6->SourceAddressSelection (interfaceIdx, route->GetDest ()));
+                        }
+                      else if (route->GetDest ().IsAny ()) /* default route */
+                        {
+                          rtentry->SetSource (m_ipv6->SourceAddressSelection (interfaceIdx, route->GetPrefixToUse ().IsAny () ? dst : route->GetPrefixToUse ()));
+                        }
+                      else
+                        {
+                          rtentry->SetSource (m_ipv6->SourceAddressSelection (interfaceIdx, route->GetDest ()));
+                        }
                     }
 
                   rtentry->SetDestination (route->GetDest ());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ripng.h ns-3.36/src/internet/model/ripng.h
--- ns-3.35/src/internet/model/ripng.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ripng.h	2022-04-30 18:23:57.874733700 -0700
@@ -310,10 +310,11 @@
   /**
    * \brief Lookup in the forwarding table for destination.
    * \param dest destination address
+   * \param setSource set source address in the route
    * \param interface output interface if any (put 0 otherwise)
    * \return Ipv6Route to route the packet to reach dest address
    */
-  Ptr<Ipv6Route> Lookup (Ipv6Address dest, Ptr<NetDevice> = 0);
+  Ptr<Ipv6Route> Lookup (Ipv6Address dest, bool setSource, Ptr<NetDevice> = 0);
 
   /**
    * Receive and process unicast packet
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-bbr.h ns-3.36/src/internet/model/tcp-bbr.h
--- ns-3.35/src/internet/model/tcp-bbr.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-bbr.h	2022-04-30 18:23:57.874733700 -0700
@@ -33,6 +33,14 @@
 
 namespace ns3 {
 
+/**
+ * \ingroup congestionOps
+ *
+ * \brief BBR congestion control algorithm
+ * 
+ * This class implement the BBR (Bottleneck Bandwidth and Round-trip propagation time)
+ * congestion control type.
+ */
 class TcpBbr : public TcpCongestionOps
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-congestion-ops.cc ns-3.36/src/internet/model/tcp-congestion-ops.cc
--- ns-3.35/src/internet/model/tcp-congestion-ops.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-congestion-ops.cc	2022-04-30 18:23:57.874733700 -0700
@@ -82,12 +82,10 @@
 
 void
 TcpCongestionOps::CongControl (Ptr<TcpSocketState> tcb,
-                               const TcpRateOps::TcpRateConnection &rc,
-                               const TcpRateOps::TcpRateSample &rs)
+                               [[maybe_unused]] const TcpRateOps::TcpRateConnection &rc,
+                               [[maybe_unused]] const TcpRateOps::TcpRateSample &rs)
 {
   NS_LOG_FUNCTION (this << tcb);
-  NS_UNUSED (rc);
-  NS_UNUSED (rs);
 }
 
 // RENO
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-congestion-ops.h ns-3.36/src/internet/model/tcp-congestion-ops.h
--- ns-3.35/src/internet/model/tcp-congestion-ops.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-congestion-ops.h	2022-04-30 18:23:57.874733700 -0700
@@ -79,9 +79,8 @@
    *
    * \param tcb internal congestion state
    */
-  virtual void Init (Ptr<TcpSocketState> tcb)
+  virtual void Init ([[maybe_unused]] Ptr<TcpSocketState> tcb)
     {
-      NS_UNUSED (tcb);
     }
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-cubic.h ns-3.36/src/internet/model/tcp-cubic.h
--- ns-3.35/src/internet/model/tcp-cubic.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-cubic.h	2022-04-30 18:23:57.874733700 -0700
@@ -43,7 +43,7 @@
  * Following the Linux implementation, we included the Hybrid Slow Start,
  * that effectively prevents the overshooting of slow start
  * while maintaining a full utilization of the network. This new type of slow
- * start can be disabled through the \Attribute{HyStart} attribute.
+ * start can be disabled through the HyStart attribute.
  *
  * CUBIC TCP is implemented and used by default in Linux kernels 2.6.19
  * and above; this version follows the implementation in Linux 3.14, which
